您的位置:首页 > 其它

POJ 3126 Prime Path

2015-08-25 15:20 441 查看
C - Prime Path
Time Limit:1000MS Memory Limit:65536KB 64bit IO Format:%I64d
& %I64u
SubmitStatusPracticePOJ
3126

Description


The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to
change the four-digit room numbers on their offices.

— It is a matter of security to change such things every now and then, to keep the enemy in the dark.

— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!

— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.

— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!

— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.

— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.

— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.

— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?

— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

1033

1733

3733

3739

3779

8779

8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033


Sample Output

6
7
0


BFS搜索质数。

题目的大概意思是说给定两个四位素数a b,要求把a变换到b

变换的过程要保证 每次变换出来的数都是一个 四位素数,而且当前这步的变换所得的素数 与 前一步得到的素数 只能有一个位不同,而且每步得到的素数都不能重复。

求从a到b最少需要的变换次数。无法变换则输出Impossible

和前面的那些下棋,找点,走迷宫的题不同,但方法还是一样的。

广度优先搜索+素数判定。

枚举个位,十位,百位,千位。

#include <stdio.h>
#include <string.h>
#include <queue>
using namespace std;
int vis[100005];
int kstart,kend;
typedef struct
{
int num,step;
}Node;
queue<Node> q;
bool isprime(int n)
{
if(n==1)
return false;
if(n==2)
return true ;
for(int i=2;i*i<=n;i++)
if(n%i==0)
return false;
return true;
}
int bfs(int start)
{
while(!q.empty())
q.pop();
vis[start]=1;
Node fir;
fir.num=start;
fir.step=0;
q.push(fir);
while(!q.empty())
{
Node fro=q.front();
q.pop();
if(fro.num==kend)
return fro.step;
int k,l;
k=fro.num%10;
l=(fro.num/10)%10;
Node nxt;
for(int i=1;i<=9;i+=2)
{
int y=(fro.num/10)*10+i;
if(y!=fro.num&&!vis[y]&&isprime(y))
{
vis[y]=1;
nxt.num=y;
nxt.step=fro.step+1;
q.push(nxt);
}
}
for(int i=0;i<=9;i++)
{
int y=(fro.num/100)*100+i*10+k;
if(y!=fro.num&&!vis[y]&&isprime(y))
{
vis[y]=1;
nxt.num=y;
nxt.step=fro.step+1;
q.push(nxt);
}
}
for(int i=0;i<=9;i++)
{
int y=(fro.num/1000)*1000+100*i+k+l*10;
if(y!=fro.num&&!vis[y]&&isprime(y))
{
vis[y]=1;
nxt.num=y;
nxt.step=fro.step+1;
q.push(nxt);
}
}
for(int i=1;i<=9;i++)
{
int y=fro.num%1000+i*1000;
if(y!=fro.num&&!vis[y]&&isprime(y))
{
vis[y]=1;
nxt.num=y;
nxt.step=fro.step+1;
q.push(nxt);
}
}
}
return -1;
}
int main()
{
int t;
scanf("%d",&t);
while(t--)
{
memset(vis,0,sizeof(vis));
scanf("%d%d",&kstart,&kend);
int ans=bfs(kstart);
if(ans==-1)
printf("Impossible\n");
else
printf("%d\n",ans);
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: